#include <phigs.h>			/* get HP-PHIGS definitions for C */
#include <stdio.h>			/* get standard I/O definitions */
#include <math.h>			/* link with library "-lm" */
#define	 deg	*3.14159265358979/180.	/* convert degrees to radians */

main()					/* file "PolylineSet.c" */
{
    Pint	WorkstnID = 1;		/* workstation identifier */
    Pint	ConnID;			/* connection identifier */
    Pint	WorkstnType = POIDDX;	/* out/in, direct, dbl bfr, Xwindow */
    Pint	TheStructure = 1;	/* structure ID (chosen by user) */
    Ppoint	TrianglePts[25][4];	/* XY data for the triangles */
    Ppoint_list	TriangleData[25];	/* point lists for the triangles */
    Ppoint_list_list Triangle;		/* whole polyline set */
    float	Theta, Radius;		/* temporary variables */
    int		I, J, K;		/* loop control variables */

    popen_phigs((char *) stderr, 0);	/* errors go to "stderr" */
    pescape_u4("/dev/screen/phigs_window", &ConnID);
    popen_ws(WorkstnID, (void *) ConnID, WorkstnType);
    popen_struct(TheStructure);
    for (I = 0; I < 25; I++) {			/* for each triangle... */
	Radius = I *  0.04;			/* each one larger than last */
	for (J = 0; J < 4; J++) {		/* for each vertex... */
	    Theta = (J * 120.0 + I * 4) deg;	/* vertex angle from center */
	    TrianglePts[I][J].x = (Radius * cos(Theta) + 1) * 0.5;
	    TrianglePts[I][J].y = (Radius * sin(Theta) + 1) * 0.5;
	}
	TriangleData[I].num_points = 4;
	TriangleData[I].points = &(TrianglePts[I][0]);
    }
    Triangle.num_point_lists = 25;
    Triangle.point_lists = TriangleData;
    pgdp_u14(&Triangle);		/* polyline set */
    pclose_struct();
    ppost_struct(WorkstnID, TheStructure, 1.0);
    pupd_ws(WorkstnID, PFLAG_PERFORM);	/* (regeneration flag) */
    pclose_ws(WorkstnID);
    pclose_phigs();
}
